import SpriteKit

class GameScene: SKScene {
  
  fileprivate var w:CGFloat = 2000
  fileprivate var h:CGFloat = 0
  
  let spaceship = SKSpriteNode(imageNamed: "Spaceship")
  var meinWinkel = 0
  var meinX = 0
  var meinY = 0
  
  override func didMove(to view: SKView) {
    // nicht ändern
    setup(view)
    
    // hier geht's los
    spaceship.position = CGPoint(x:200, y: 200)
    spaceship.zRotation = winkel(-45)
    spaceship.zPosition = 1
    spaceship.color = SKColor.red
    spaceship.colorBlendFactor = 1
    self.addChild(spaceship)
    
    let spaceship2 = SKSpriteNode(imageNamed: "Spaceship")
    spaceship2.position = CGPoint(x:1800, y: 1300)
    spaceship2.zRotation = winkel(135)
    spaceship2.zPosition = 1
    spaceship2.color = SKColor.blue
    spaceship2.colorBlendFactor = 0.3
    self.addChild(spaceship2)

    let s3 = SKSpriteNode(imageNamed: "Spaceship")
    s3.position = CGPoint(x:1000, y: 700)
    s3.zRotation = winkel(0)
    s3.zPosition = 1
    s3.xScale = 3
    s3.yScale = 2
    self.addChild(s3)

  }
  
  override func update(_ currentTime: TimeInterval) {
    meinWinkel = meinWinkel + 5
    spaceship.zRotation = winkel(meinWinkel)
    
    meinX = meinX + 10
    meinY = meinY + 10
    spaceship.position = CGPoint(x: meinX, y: meinY)
  }
  
  
  
  
  
  
  
  
  
  
  // Grad in Bogenmaß umrechnen
  func winkel(_ n: Int) -> CGFloat {
    return CGFloat(n) / 180 * .pi
  }
  
  
  // Initialisierung
  func setup(_ view: SKView) {
    let w = CGFloat(2000)
    let h = w / view.bounds.width * view.bounds.height
    self.size = CGSize(width: w, height: h)
    show("Breite: \(w)   Höhe: \(h)")
    
    let midPt = CGPoint(x: w / 2, y: h / 2)
    
    let milkyway = SKSpriteNode(imageNamed: "milky-way")
    milkyway.position = midPt
    milkyway.zPosition = 0
    self.addChild(milkyway)
    
  }
  
  
  // Ausgabe wie mit print, aber vorangestelltes '> ',
  // damit Ausgaben gefiltert werden können
  func show(_ s:String) {
    print("out> \(s)")
  }
  
}
