import SpriteKit

class GameScene: SKScene {
  
  fileprivate var w:CGFloat = 2000
  fileprivate var h:CGFloat = 0
  
  override func didMove(to view: SKView) {
    // nicht ändern
    setup(view)
    
    // hier geht's los
    let spaceship = SKSpriteNode(imageNamed: "Spaceship")
    spaceship.position = CGPoint(x:1000, y: 700)
    spaceship.zRotation = winkel(0)
    spaceship.zPosition = 1
    self.addChild(spaceship)
    
  }
  
  
  
  
  
  
  
  
  
  
  
  
  // Grad in Bogenmaß umrechnen
  func winkel(_ n: Int) -> CGFloat {
    return CGFloat(n) / 180 * .pi
  }
  
  
  // Initialisierung
  func setup(_ view: SKView) {
    let w = CGFloat(2000)
    let h = w / view.bounds.width * view.bounds.height
    self.size = CGSize(width: w, height: h)
    show("Breite: \(w)   Höhe: \(h)")
    
    let midPt = CGPoint(x: w / 2, y: h / 2)
    
    let milkyway = SKSpriteNode(imageNamed: "milky-way")
    milkyway.position = midPt
    milkyway.zPosition = 0
    self.addChild(milkyway)
    
  }
  
  
  // Ausgabe wie mit print, aber vorangestelltes '> ',
  // damit Ausgaben gefiltert werden können
  func show(_ s:String) {
    print("out> \(s)")
  }
  
}
